Index: /palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4802)
+++ /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4803)
@@ -1,22 +1,21 @@
 !> @file plant_canopy_model_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
 ! Copyright 2017-2020 Institute of Computer Science of the
 !                     Czech Academy of Sciences, Prague
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -27,6 +26,9 @@
 ! -----------------
 ! $Id$
-! Consider basal-area density as an additional sink for momentum in the
-! prognostic equations for momentum and SGS TKE
+! file re-formatted to follow the PALM coding standard
+!
+! 4770 2020-11-03 14:04:53Z suehring
+! Consider basal-area density as an additional sink for momentum in the prognostic equations for
+! momentum and SGS TKE
 !
 ! 4768 2020-11-02 19:11:23Z suehring
@@ -35,24 +37,23 @@
 ! 4671 2020-09-09 20:27:58Z pavelkrc
 ! Implementation of downward facing USM and LSM surfaces
-! 
+!
 ! 4535 2020-05-15 12:07:23Z raasch
 ! bugfix for restart data format query
-! 
+!
 ! 4525 2020-05-10 17:05:07Z raasch
 ! bugfix for reading/writing pcm_...rate_av with MPI-IO
-! 
+!
 ! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO for reading local arrays
-! 
+!
 ! 4515 2020-04-30 16:37:18Z suehring
 ! Rename error number again since this was recently given in -r 4511
-! 
+!
 ! 4514 2020-04-30 16:29:59Z suehring
-! - Bugfix in output of pcm_heatrate_av in a restart run. In order to fix this, 
-!   pch_index is now output for a restart run. Therefore, define global restart
-!   routines.
-! - Error message number renamed and check for PA0505 revised in order to also
-!   consider natural surfaces with plant-canopy.
-! 
+! - Bugfix in output of pcm_heatrate_av in a restart run. In order to fix this, pch_index is now
+!   output for a restart run. Therefore, define global restart routines.
+! - Error message number renamed and check for PA0505 revised in order to also consider natural
+!   surfaces with plant-canopy.
+!
 ! 4495 2020-04-13 20:11:20Z raasch
 ! restart data handling with MPI-IO added
@@ -63,41 +64,38 @@
 ! (salim) removed the error message PA0672 to consider PC 3d data via ascii file
 !
-! 4392 2020-01-31 16:14:57Z pavelkrc (resler) 
-! Make pcm_heatrate_av, pcm_latentrate_av public to allow calculation
-! of averaged Bowen ratio in the user procedure
+! 4392 2020-01-31 16:14:57Z pavelkrc (resler)
+! Make pcm_heatrate_av, pcm_latentrate_av public to allow calculation of averaged Bowen ratio in the
+! user procedure
 !
 ! 4381 2020-01-20 13:51:46Z suehring
 ! Give error message 313 only once
-! 
+!
 ! 4363 2020-01-07 18:11:28Z suehring
 ! Fix for last commit
-! 
+!
 ! 4362 2020-01-07 17:15:02Z suehring
-! Input of plant canopy variables from static driver moved to plant-canopy 
-! model
-! 
+! Input of plant canopy variables from static driver moved to plant-canopy model
+!
 ! 4361 2020-01-07 12:22:38Z suehring
 ! - Remove unused arrays in pmc_rrd_local
 ! - Remove one exchange of ghost points
-! 
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! - Bugfix, read restart data for time-averaged pcm output quantities
 ! - Output of plant-canopy quantities will fill values
-! 
+!
 ! 4356 2019-12-20 17:09:33Z suehring
-! Correct single message call, local check must be given by the respective
-! mpi rank.
-! 
+! Correct single message call, local check must be given by the respective mpi rank.
+!
 ! 4346 2019-12-18 11:55:56Z motisi
-! Introduction of wall_flags_total_0, which currently sets bits based on static
-! topography information used in wall_flags_static_0
-! 
+! Introduction of wall_flags_total_0, which currently sets bits based on static topography
+! information used in wall_flags_static_0
+!
 ! 4342 2019-12-16 13:49:14Z Giersch
-! Use statements moved to module level, ocean dependency removed, redundant
-! variables removed
-! 
+! Use statements moved to module level, ocean dependency removed, redundant variables removed
+!
 ! 4341 2019-12-16 10:43:49Z motisi
-! - Unification of variable names: pc_-variables now pcm_-variables 
-!   (pc_latent_rate, pc_heating_rate, pc_transpiration_rate)
+! - Unification of variable names: pc_-variables now pcm_-variables (pc_latent_rate,
+!                                  pc_heating_rate, pc_transpiration_rate)
 ! - Removal of pcm_bowenratio output
 ! - Renamed canopy-mode 'block' to 'homogeneous'
@@ -106,80 +104,77 @@
 ! - Replacement of k_wall by topo_top_ind
 ! - Removal of Else-Statement in tendency-calculation
-! 
+!
 ! 4335 2019-12-12 16:39:05Z suehring
 ! Fix for LAD at building edges also implemented in vector branch.
-! 
+!
 ! 4331 2019-12-10 18:25:02Z suehring
 ! Typo corrected
-! 
+!
 ! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
-! 
+!
 ! 4314 2019-11-29 10:29:20Z suehring
-! - Bugfix, plant canopy was still considered at building edges on for the u- 
-!   and v-component.
-! - Relax restriction of LAD on building tops. LAD is only omitted at 
-!   locations where building grid points emerged artificially by the 
-!   topography filtering.
-! 
+! - Bugfix, plant canopy was still considered at building edges on for the u- and v-component.
+! - Relax restriction of LAD on building tops. LAD is only omitted at locations where building grid
+!   points emerged artificially by the topography filtering.
+!
 ! 4309 2019-11-26 18:49:59Z suehring
 ! Typo
-! 
+!
 ! 4302 2019-11-22 13:15:56Z suehring
 ! Omit tall canopy mapped on top of buildings
-! 
+!
 ! 4279 2019-10-29 08:48:17Z scharf
 ! unused variables removed
-! 
+!
 ! 4258 2019-10-07 13:29:08Z scharf
 ! changed check for static driver and fixed bugs in initialization and header
-! 
+!
 ! 4258 2019-10-07 13:29:08Z suehring
 ! Check if any LAD is prescribed when plant-canopy model is applied.
-! 
+!
 ! 4226 2019-09-10 17:03:24Z suehring
 ! Bugfix, missing initialization of heating rate
-! 
+!
 ! 4221 2019-09-09 08:50:35Z suehring
 ! Further bugfix in 3d data output for plant canopy
-! 
+!
 ! 4216 2019-09-04 09:09:03Z suehring
 ! Bugfixes in 3d data output
-! 
+!
 ! 4205 2019-08-30 13:25:00Z suehring
 ! Missing working precision + bugfix in calculation of wind speed
-! 
+!
 ! 4188 2019-08-26 14:15:47Z suehring
 ! Minor adjustment in error number
-! 
+!
 ! 4187 2019-08-26 12:43:15Z suehring
 ! Give specific error numbers instead of PA0999
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4168 2019-08-16 13:50:17Z suehring
 ! Replace function get_topography_top_index by topo_top_ind
-! 
+!
 ! 4127 2019-07-30 14:47:10Z suehring
-! Output of 3D plant canopy variables changed. It is now relative to the local
-! terrain rather than located at the acutal vertical level in the model. This 
-! way, the vertical dimension of the output can be significantly reduced. 
-! (merge from branch resler) 
-! 
+! Output of 3D plant canopy variables changed. It is now relative to the local terrain rather than
+! located at the acutal vertical level in the model. This way, the vertical dimension of the output
+! can be significantly reduced.
+! (merge from branch resler)
+!
 ! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction 
-! of additional debug messages
-! 
+! Changes related to global restructuring of location messages and introduction of additional debug
+! messages
+!
 ! 3864 2019-04-05 09:01:56Z monakurppa
 ! unsed variables removed
-! 
+!
 ! 3745 2019-02-15 18:57:56Z suehring
-! Bugfix in transpiration, floating invalid when temperature 
-! becomes > 40 degrees
-! 
+! Bugfix in transpiration, floating invalid when temperature becomes > 40 degrees
+!
 ! 3744 2019-02-15 18:38:58Z suehring
 ! Some interface calls moved to module_interface + cleanup
-! 
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! unused variables removed
@@ -190,65 +185,65 @@
 ! Description:
 ! ------------
-!> 1) Initialization of the canopy model, e.g. construction of leaf area density 
-!> profile (subroutine pcm_init).
-!> 2) Calculation of sinks and sources of momentum, heat and scalar concentration 
-!> due to canopy elements (subroutine pcm_tendency).
+!> 1) Initialization of the canopy model, e.g. construction of leaf area density profile
+!>    (subroutine pcm_init).
+!> 2) Calculation of sinks and sources of momentum, heat and scalar concentration due to canopy
+!>    elements (subroutine pcm_tendency).
 !
 ! @todo - precalculate constant terms in pcm_calc_transpiration_rate
 ! @todo - unify variable names (pcm_, pc_, ...)
 ! @todo - get rid-off dependency on radiation model
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  MODULE plant_canopy_model_mod
 
-    USE arrays_3d,                                                             &
+    USE arrays_3d,                                                                                 &
         ONLY:  dzu, dzw, e, exner, hyp, pt, q, s, tend, u, v, w, zu, zw
 
-    USE basic_constants_and_equations_mod,                                     &
+    USE basic_constants_and_equations_mod,                                                         &
         ONLY:  c_p, degc_to_k, l_v, lv_d_cp, r_d, rd_d_rv
 
-    USE bulk_cloud_model_mod,                                                  &
+    USE bulk_cloud_model_mod,                                                                      &
         ONLY: bulk_cloud_model, microphysics_seifert
 
-    USE control_parameters,                                                    &
-        ONLY: average_count_3d,                                                &
-              coupling_char,                                                   &
-              debug_output,                                                    &
-              dt_3d,                                                           &
-              dz,                                                              &
-              humidity,                                                        &
-              land_surface,                                                    &
-              length,                                                          &
-              message_string,                                                  &
-              ocean_mode,                                                      &
-              passive_scalar,                                                  &
-              plant_canopy,                                                    &
-              restart_data_format_output,                                      &
-              restart_string,                                                  &
+    USE control_parameters,                                                                        &
+        ONLY: average_count_3d,                                                                    &
+              coupling_char,                                                                       &
+              debug_output,                                                                        &
+              dt_3d,                                                                               &
+              dz,                                                                                  &
+              humidity,                                                                            &
+              land_surface,                                                                        &
+              length,                                                                              &
+              message_string,                                                                      &
+              ocean_mode,                                                                          &
+              passive_scalar,                                                                      &
+              plant_canopy,                                                                        &
+              restart_data_format_output,                                                          &
+              restart_string,                                                                      &
               urban_surface
 
-    USE grid_variables,                                                        &
+    USE grid_variables,                                                                            &
         ONLY:  dx, dy
 
-    USE indices,                                                               &
-        ONLY:  nbgp, nxl, nxlg, nxlu, nxr, nxrg, nyn, nyng, nys, nysg, nysv,   &
-               nz, nzb, nzt, topo_top_ind, wall_flags_total_0
+    USE indices,                                                                                   &
+        ONLY:  nbgp, nxl, nxlg, nxlu, nxr, nxrg, nyn, nyng, nys, nysg, nysv, nz, nzb, nzt,         &
+               topo_top_ind, wall_flags_total_0
 
     USE kinds
 
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  input_pids_static,                                              &
-               char_fill,                                                      &
-               check_existence,                                                &
-               close_input_file,                                               &
-               get_attribute,                                                  &
-               get_dimension_length,                                           &
-               get_variable,                                                   &
-               inquire_num_variables,                                          &
-               inquire_variable_names,                                         &
-               input_file_static,                                              &
-               num_var_pids,                                                   &
-               open_read_file,                                                 &
-               pids_id,                                                        &
-               real_3d,                                                        &
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  char_fill,                                                                          &
+               check_existence,                                                                    &
+               close_input_file,                                                                   &
+               get_attribute,                                                                      &
+               get_dimension_length,                                                               &
+               get_variable,                                                                       &
+               input_file_static,                                                                  &
+               input_pids_static,                                                                  &
+               inquire_num_variables,                                                              &
+               inquire_variable_names,                                                             &
+               num_var_pids,                                                                       &
+               open_read_file,                                                                     &
+               pids_id,                                                                            &
+               real_3d,                                                                            &
                vars_pids
 
@@ -260,5 +255,5 @@
                wrd_mpi_io
 
-    USE surface_mod,                                                           &
+    USE surface_mod,                                                                               &
         ONLY: surf_def_h, surf_lsm_h, surf_usm_h
 
@@ -266,32 +261,30 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=30)   ::  canopy_mode = 'homogeneous'           !< canopy coverage
-    LOGICAL              ::  plant_canopy_transpiration = .FALSE.  !< flag to switch calculation of transpiration and corresponding latent heat
-                                                                   !< for resolved plant canopy inside radiation model
-                                                                   !< (calls subroutine pcm_calc_transpiration_rate from module plant_canopy_mod)
-
+    CHARACTER (LEN=30) ::  canopy_mode = 'homogeneous'           !< canopy coverage
     INTEGER(iwp) ::  pch_index = 0                                 !< plant canopy height/top index
+
     INTEGER(iwp) ::  lad_vertical_gradient_level_ind(10) = -9999   !< lad-profile levels (index)
 
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  pch_index_ji     !< local plant canopy top
 
-    LOGICAL ::  calc_beta_lad_profile = .FALSE.   !< switch for calc. of lad from beta func.
-
-    REAL(wp) ::  alpha_lad = 9999999.9_wp         !< coefficient for lad calculation
-    REAL(wp) ::  beta_lad = 9999999.9_wp          !< coefficient for lad calculation
-    REAL(wp) ::  canopy_drag_coeff = 0.0_wp       !< canopy drag coefficient (parameter)
-    REAL(wp) ::  cthf = 0.0_wp                    !< canopy top heat flux
-    REAL(wp) ::  dt_plant_canopy = 0.0_wp         !< timestep account. for canopy drag
-    REAL(wp) ::  ext_coef = 0.6_wp                !< extinction coefficient
-    REAL(wp) ::  lad_surface = 0.0_wp             !< lad surface value
-    REAL(wp) ::  lai_beta = 0.0_wp                !< leaf area index (lai) for lad calc.
-    REAL(wp) ::  leaf_scalar_exch_coeff = 0.0_wp  !< canopy scalar exchange coeff.
-    REAL(wp) ::  leaf_surface_conc = 0.0_wp       !< leaf surface concentration
-
+    LOGICAL ::  calc_beta_lad_profile = .FALSE.       !< switch for calc. of lad from beta func.
+    LOGICAL ::  plant_canopy_transpiration = .FALSE.  !< flag to switch calculation of transpiration and corresponding latent heat
+                                                      !< for resolved plant canopy inside radiation model
+                                                      !< (calls subroutine pcm_calc_transpiration_rate from module plant_canopy_mod)
+
+    REAL(wp) ::  alpha_lad = 9999999.9_wp                        !< coefficient for lad calculation
+    REAL(wp) ::  beta_lad = 9999999.9_wp                         !< coefficient for lad calculation
+    REAL(wp) ::  canopy_drag_coeff = 0.0_wp                      !< canopy drag coefficient (parameter)
+    REAL(wp) ::  cthf = 0.0_wp                                   !< canopy top heat flux
+    REAL(wp) ::  dt_plant_canopy = 0.0_wp                        !< timestep account. for canopy drag
+    REAL(wp) ::  ext_coef = 0.6_wp                               !< extinction coefficient
+    REAL(wp) ::  lad_surface = 0.0_wp                            !< lad surface value
+    REAL(wp) ::  lad_type_coef(0:10) = 1.0_wp                    !< multiplicative coeficients for particular types
+                                                                 !< of plant canopy (e.g. deciduous tree during winter)
     REAL(wp) ::  lad_vertical_gradient(10) = 0.0_wp              !< lad gradient
     REAL(wp) ::  lad_vertical_gradient_level(10) = -9999999.9_wp !< lad-prof. levels (in m)
-
-    REAL(wp) ::  lad_type_coef(0:10) = 1.0_wp   !< multiplicative coeficients for particular types
-                                                !< of plant canopy (e.g. deciduous tree during winter)
+    REAL(wp) ::  lai_beta = 0.0_wp                               !< leaf area index (lai) for lad calc.
+    REAL(wp) ::  leaf_scalar_exch_coeff = 0.0_wp                 !< canopy scalar exchange coeff.
+    REAL(wp) ::  leaf_surface_conc = 0.0_wp                      !< leaf surface concentration
 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  lad            !< leaf area density
@@ -302,9 +295,8 @@
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  lad_s                    !< lad on scalar-grid
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pcm_heating_rate         !< plant canopy heating rate
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pcm_heatrate_av          !< array for averaging plant canopy sensible heating rate
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pcm_latent_rate          !< plant canopy latent heating rate
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pcm_latentrate_av        !< array for averaging plant canopy latent heating rate
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pcm_transpiration_rate   !< plant canopy transpiration rate
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pcm_latent_rate          !< plant canopy latent heating rate
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pcm_heatrate_av          !< array for averaging plant canopy sensible heating rate
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pcm_latentrate_av        !< array for averaging plant canopy latent heating rate
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pcm_transpirationrate_av !< array for averaging plant canopy transpiration rate
 
@@ -316,27 +308,26 @@
 
     PRIVATE
-    
+
 !
 !-- Public functions
-    PUBLIC pcm_calc_transpiration_rate,                                       &
-           pcm_check_data_output,                                             &
-           pcm_check_parameters,                                              &
-           pcm_3d_data_averaging,                                             &
-           pcm_data_output_3d,                                                &
-           pcm_define_netcdf_grid,                                            &
-           pcm_header,                                                        &
-           pcm_init,                                                          &
-           pcm_parin,                                                         &
-           pcm_rrd_global,                                                    &
-           pcm_rrd_local,                                                     &
-           pcm_tendency,                                                      &
-           pcm_wrd_global,                                                    &
+    PUBLIC pcm_calc_transpiration_rate,                                                            &
+           pcm_check_data_output,                                                                  &
+           pcm_check_parameters,                                                                   &
+           pcm_3d_data_averaging,                                                                  &
+           pcm_data_output_3d,                                                                     &
+           pcm_define_netcdf_grid,                                                                 &
+           pcm_header,                                                                             &
+           pcm_init,                                                                               &
+           pcm_parin,                                                                              &
+           pcm_rrd_global,                                                                         &
+           pcm_rrd_local,                                                                          &
+           pcm_tendency,                                                                           &
+           pcm_wrd_global,                                                                         &
            pcm_wrd_local
 
 !
 !-- Public variables and constants
-    PUBLIC canopy_drag_coeff, pcm_heating_rate, pcm_transpiration_rate,       &
-           pcm_latent_rate, canopy_mode, cthf, dt_plant_canopy, lad, lad_s,   &
-           pch_index, plant_canopy_transpiration,                             &
+    PUBLIC canopy_drag_coeff, pcm_heating_rate, pcm_transpiration_rate, pcm_latent_rate,           &
+           canopy_mode, cthf, dt_plant_canopy, lad, lad_s, pch_index, plant_canopy_transpiration,  &
            pcm_heatrate_av, pcm_latentrate_av
 
@@ -348,5 +339,5 @@
        MODULE PROCEDURE pcm_check_data_output
     END INTERFACE pcm_check_data_output
-    
+
     INTERFACE pcm_check_parameters
        MODULE PROCEDURE pcm_check_parameters
@@ -364,9 +355,9 @@
        MODULE PROCEDURE pcm_define_netcdf_grid
     END INTERFACE pcm_define_netcdf_grid
-    
+
      INTERFACE pcm_header
        MODULE PROCEDURE pcm_header
-    END INTERFACE pcm_header        
-    
+    END INTERFACE pcm_header
+
     INTERFACE pcm_init
        MODULE PROCEDURE pcm_init
